﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Diagnostics;
using System.Linq;
using System.Text;
using System.Threading;
using System.Threading.Tasks;
using AsyncReduxUtils;

namespace DelegateBasedAsync
{
    public class SlowProcessViewModel : INotifyPropertyChanged
    {

        public string SlowProcess()
        {
            var token = StopwatchHelper.StartNew(TimerType.WORKER_TIMER);

            StartData = "Slow process started.";

            var rv = "";

            for (var i = 0; i <= 5; i++)
            {
                if (IsCanceled)
                {
                    rv = "Slow process canceled.";
                    break;
                }

                Thread.Sleep(TimeSpan.FromSeconds(1));
                ProgressData = i;
            }

            if (rv == String.Empty)
                rv = "Slow process completed.";

            StopwatchHelper.Stop(token);

            return rv;
        }

        private string _startData = "";
        public string StartData
        {
            get
            {
                return _startData;
            }
            set
            {
                _startData = value;
                RaisePropertyChanged("StartData");
            }
        }

        private int _progressData = 0;
        public int ProgressData
        {
            get
            {
                return _progressData;
            }
            set
            {
                _progressData = value;
                RaisePropertyChanged("ProgressData");
            }
        }

        private bool _isCanceled = false;
        public bool IsCanceled
        {
            get
            {
                return _isCanceled;
            }
            set
            {
                _isCanceled = value;
                RaisePropertyChanged("IsCanceled");
            }
        }

        #region Implement INotifyPropertyChanged

        public void RaisePropertyChanged(string name)
        {
            if (PropertyChanged != null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(name));
            }
        }


        public event PropertyChangedEventHandler PropertyChanged;

        #endregion

    }
}