﻿using System;
using System.Diagnostics;
using System.Threading;
using System.Windows;
using AsyncReduxUtils;

namespace EventBasedAsync
{
    public partial class MainWindow : Window
    {
        private int taskId = 1;

        public MainWindow()
        {
            var token = StopwatchHelper.StartNew(TimerType.MAIN_TIMER);
            StopwatchHelper.Stop(token);

            InitializeComponent();
        }

        private void StartSlowProcessButton_Click(object sender, RoutedEventArgs e)
        {
            var token = StopwatchHelper.StartNew(TimerType.START_CLICK_TIMER);

            // Create new UserControl and add it to the StackPanel
            var uc = new SlowProcessView();
            uc.ViewModel = new SlowProcessViewModel();
            uc.InitializeEvents();

            uc.DataContext = uc.ViewModel;
            MainStackPanel.Children.Add(uc);

            // Get a unique task id, in a thread-safe manner, for task lifecycle management
            var tid = Interlocked.Increment(ref taskId);
            uc.ViewModel.SlowProcessAsync(tid);

            StopwatchHelper.Stop(token);
        }
    }
}
