﻿using System;
using System.Windows;
using System.Windows.Controls;
using System.ComponentModel;
using System.Threading;
using System.Diagnostics;
using AsyncReduxUtils;

namespace EventBasedAsync
{
    // Interaction logic for SlowProcessView.xaml
    public partial class SlowProcessView : UserControl
    {
        public SlowProcessView()
        {
            InitializeComponent();
        }

        public void InitializeEvents()
        {
            // Initialize ViewModel events with View-based event handler methods
            ViewModel.SlowProcessStarted += new SlowProcessStartedEventHandler(SlowProcessStartedEventHandlerMethod);
            ViewModel.SlowProcessProgressChanged += new ProgressChangedEventHandler(SlowProcessProgressEventHandlerMethod);
        }

        public SlowProcessViewModel ViewModel { get; set; }

        private void SlowProcessStartedEventHandlerMethod(EventArgs e)
        {
            var token = StopwatchHelper.StartNew(TimerType.ASYNCOP_POST_TIMER);

            StartedText.Text = "Slow process started.";

            StopwatchHelper.Stop(token);
        }

        public void SlowProcessProgressEventHandlerMethod(ProgressChangedEventArgs e)
        {
            var token = StopwatchHelper.StartNew(TimerType.ASYNCOP_POST_TIMER);

            ProgressText.Text = Convert.ToString(e.ProgressPercentage / 20);
            ProgressBar.Value = e.ProgressPercentage / 20;

            StopwatchHelper.Stop(token);
        }

        private void CancelSlowProcessButton_Click(object sender, RoutedEventArgs e)
        {
            var token = StopwatchHelper.StartNew(TimerType.CANCEL_CLICK_TIMER);

            ViewModel.CancelAsync(ViewModel.Tag);

            StopwatchHelper.Stop(token);
        }
    }
}
