﻿using System;
using System.Diagnostics;
using System.Threading;
using System.Threading.Tasks;
using System.Windows;
using AsyncReduxUtils;

namespace TaskBasedAsync
{
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            var token = StopwatchHelper.StartNew(TimerType.MAIN_TIMER);

            InitializeComponent();

            StopwatchHelper.Stop(token);
        }

        private void StartSlowProcessButton_Click(object sender, RoutedEventArgs e)
        {
            var token = StopwatchHelper.StartNew(TimerType.START_CLICK_TIMER);

            // Create new UserControl and add it to the StackPanel
            var uc = new SlowProcessView();
            uc.ViewModel = new SlowProcessViewModel();
            uc.DataContext = uc.ViewModel;
            MainStackPanel.Children.Add(uc);

            // Call our asynchronous process
            Task<string> task = uc.ViewModel.SlowProcessAsync();

            StopwatchHelper.Stop(token);

            // Artificial wait to demonstrate monitoring and coordination capability of TAP
            var waitToken = StopwatchHelper.StartNew(TimerType.WAIT_TIMER);
            task.Wait(TimeSpan.FromSeconds(1));
            StopwatchHelper.Stop(waitToken);
        }
    }
}
